#!/usr/bin/env zsh

LIST=$1
ROBOT=${2:-fechner.net}
NEWLIST=${3:-$LIST}
ARCHIVE=/usr/mailman/archives/private/$LIST.mbox/$LIST.mbox

[[ -n "$LIST" ]] || { echo "list may not be empty" ; exit 1 }
[[ -f "/usr/local/etc/sympa/$ROBOT/robot.conf" ]] || { echo "robot does not exist" ; exit 1 }

echo "importing $LIST as $NEWLIST@$ROBOT"
read -q "REPLY?is this correct? [yN] "
[[ "$REPLY" = "y" ]] || exit

set -e
set -x

INPUT=$(mktemp)
/usr/local/mailman/bin/config_list -o $INPUT $LIST
sed -e s/\ \'/\ u\'/ -e s/\ \"/\ u\"/ -i $INPUT
echo "new_listname = u'$NEWLIST'" >> $INPUT
echo "robot = u'$ROBOT'" >> $INPUT
awk '/^wwsympa_url/ { print "url = u\""$2"\""; }' < /usr/local/etc/sympa/$ROBOT/robot.conf >> $INPUT

XML=$(mktemp)
./gen_config.py $INPUT $XML
chmod 644 $XML
/usr/local/bin/sympa.pl --create_list --robot $ROBOT --input_file $XML
rm $XML

#import archive
if [[ -f "$ARCHIVE" ]] ; then
	TMP=$(TMPDIR=/tmp mktemp)
	cp /usr/local/mailman/archives/private/$LIST.mbox/$LIST.mbox $TMP
	chmod 644 $TMP
	./import_mbox.sh $TMP $NEWLIST $ROBOT
	rm $TMP
fi

# add members
/usr/local/mailman/bin/list_members -f $LIST | tr -d '"\\' | sed -e 's:\(.*\) <\(.*\)>:\2 \1:' -e "s:^:QUIET ADD $NEWLIST :" | ./send_command.sh $ROBOT

# sends a mail to every digest user, thus disabled
# set digest members to digest mode
#for digest in "$(list_members -d $LIST)" ; do
#  echo "QUIET SET $LIST DIGEST" | send_command.sh fs.lmu.de $digest
#done

# we skip this for now
#/usr/local/mailman/bin/rmlist $LIST

./notify_owner.py $INPUT
rm $INPUT
